%function cim = harris1(img)

%, sigma, thresh, radius, disp)
    
  %  error(nargchk(2,5,nargin));
    sigma = 1;
    thresh1 = 0.1;
    thresh2 = 0.5;
 
    dx = [-1 0 1; -2 0 2; -1 0 1]; % Sobel Derivative masks
    dy = dx';
    
    Ix = imfilter(img,dx);
    Iy = imfilter(img,dy);
    
    % Generate Gaussian filter of size 6*sigma (+/- 3sigma) and of
    % minimum size 1x1.
    g = fspecial('gaussian',max(1,fix(6*sigma)), sigma);
    
    Ix2 = imfilter(Ix.^2,g); % Smoothed squared image derivatives
    Iy2 = imfilter(Iy.^2, g);
    Ixy = imfilter(Ix.*Iy, g);

    den = Ix2+Iy2;
    
    % remove zeros
    idx = find(den<eps);
    den(idx)=eps;
    scl = max(max(den));
    den = den/scl;

    num = sqrt((Ix2-Iy2).^2+4.0*Ixy.^2);
    num = num/scl;
    
    
    figure(1);
    imshow(img);
    figure(2);
    imshow(den);
    imwrite(den,'den.jpg');
 
    cim = 1-num./den;

    figure(3);
    imshow(cim);
    imwrite(cim,'cim.jpg');
    
    
    mask = den>thresh1;
    rmask = cim.*mask;
    figure(4);
    imshow(rmask);
    imwrite(rmask,'rmask.jpg');
    
    
    [L N] = bwlabel(rmask>thresh2);
    s = regionprops(L,'Centroid');
    
    for k=1:N
        cen = s(k).Centroid;
        x(k)=cen(1);
        y(k)=cen(2);
    end
    
    figure(5);
    imshow(img);
    hold on;
    plot(x,y,'y+');
    hold off